'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.decorator_with_options = decorator_with_options;

var _react = require('react');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _hoistNonReactStatics = require('hoist-non-react-statics');

var _hoistNonReactStatics2 = _interopRequireDefault(_hoistNonReactStatics);

var _context = require('./context');

var _context2 = _interopRequireDefault(_context);

var _wrapper = require('./wrapper');

var _wrapper2 = _interopRequireDefault(_wrapper);

var _connect = require('./connect');

var _connect2 = _interopRequireDefault(_connect);

var _configuration = require('../configuration');

var _reducer = require('../reducer');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// <Form
// 	action={this.submit}>
//
// 	<Field
// 		component={Text_input}
// 		value="Text"
// 		validate={this.validate_email}
// 		error="Optional externally set error (aside validation)"/>
//
// 	<button type="submit">Submit</button>
// </Form>
//
// validate_email(value) { return 'Error message' }
//
// submit(values) { ... }
//
function decorator_with_options() {
	var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

	options = normalize_options(options);

	return function createFormComponent(FormComponent) {
		var _class, _temp2;

		var Form = (_temp2 = _class = function (_Component) {
			_inherits(Form, _Component);

			function Form() {
				var _ref;

				var _temp, _this, _ret;

				_classCallCheck(this, Form);

				for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
					args[_key] = arguments[_key];
				}

				return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Form.__proto__ || Object.getPrototypeOf(Form)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
					submitting: undefined

					// The stored field info is used to `validate()` field `value`s 
					// and set the corresponding `error`s
					// when calling `set(field, value)` and `clear(field)`.
					// It also holds initial field values for form `reset()`.
				}, _this.fields = {}, _this.report_if_form_is_abandoned = function () {
					// If the form is already submitted
					// then it's not abandoned.
					if (_this.submitted) {
						return;
					}

					// Get the latest focused form field
					var field = _this.get_latest_focused_field();

					// If no form field was ever focused
					// then the form is not being abandoned.
					if (!field) {
						return;
					}

					var onAbandoned = _this.props.onAbandoned;


					_this.stop_form_abandoned_listener();

					if (onAbandoned) {
						onAbandoned(_this.props, field, _this.get_field_value(field));
					}
				}, _this.reset = function () {
					var _this$props = _this.props,
					    fields = _this$props.fields,
					    initial_values = _this$props.initial_values;


					for (var _iterator = Object.keys(fields), _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
						var _ref2;

						if (_isArray) {
							if (_i >= _iterator.length) break;
							_ref2 = _iterator[_i++];
						} else {
							_i = _iterator.next();
							if (_i.done) break;
							_ref2 = _i.value;
						}

						var field = _ref2;

						_this.set_field(field, initial_values[field]);
					}

					// Make the form "untouched" again
					_this.reset_form_invalid_indication();

					// Autofocus the form (if not configured otherwise)
					if (options.autofocus !== false) {
						_this.focus();
					}
				}, _this.focus = function (field) {
					var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _this.props;

					// Focus on the first form field by default
					if (!field) {
						field = _this.initially_first_field;
					}

					_this.focus_field(field);
				}, _this.reset_form_invalid_indication = function () {
					_this.props.reset_form_invalid_indication(_this.props.id);
				}, _this.form_submitted = function () {
					_this.submitted = true;
					_this.stop_form_abandoned_listener();

					var onSubmitted = _this.props.onSubmitted;


					if (onSubmitted) {
						onSubmitted(_this.props);
					}

					// Return a non-undefined value so that `bluebird` doesn't complain.
					// http://bluebirdjs.com/docs/warning-explanations.html#warning-a-promise-was-created-in-a-handler-but-was-not-returned-from-it
					return null;
				}, _this.handle_error = function (error) {
					var handle_error = options.onError || (0, _configuration.get_configuration)().defaultErrorHandler;
					return handle_error(error, _this.props);
				}, _this.submit = function (before_submit, action) {
					if (!action) {
						action = before_submit;
						before_submit = undefined;
					}

					if (!action) {
						throw new Error('No action specified for form "submit"');
					}

					return function (event) {
						// Not returning the `Promise`
						// so that `bluebird` doesn't complain.
						_this.on_submit(event, before_submit, action);
					};
				}, _this.focus_field = function (field) {
					var _this$props2 = _this.props,
					    id = _this$props2.id,
					    focus_field = _this$props2.focus_field;


					focus_field(id, field);
				}, _this.scroll_to_field = function (field) {
					var _this$props3 = _this.props,
					    id = _this$props3.id,
					    scroll_to_field = _this$props3.scroll_to_field;


					scroll_to_field(id, field);
				}, _this.clear_field = function (field) {
					var _this$props4 = _this.props,
					    id = _this$props4.id,
					    values = _this$props4.values,
					    clear_field = _this$props4.clear_field;

					// If this field hasn't been "registered" yet then ignore.

					if (!_this.fields[field]) {
						return;
					}

					var validate = _this.fields[field].validate;
					clear_field(id, field, validate(undefined, values));
				}, _this.get_field_value = function (field) {
					var values = _this.props.values;


					return values[field];
				}, _this.set_field = function (field, value) {
					var _this$props5 = _this.props,
					    id = _this$props5.id,
					    values = _this$props5.values,
					    set_field = _this$props5.set_field;


					var validate = _this.fields[field].validate;
					set_field(id, field, value, validate(value, values));
				}, _this.get_latest_focused_field = function () {
					var latest_focused_field = _this.props.misc.latest_focused_field;


					return latest_focused_field;
				}, _this.store_instance = function (ref) {
					_this.user_form = ref;
				}, _temp), _possibleConstructorReturn(_this, _ret);
			}

			_createClass(Form, [{
				key: 'componentWillMount',
				value: function componentWillMount() {
					var _props = this.props,
					    id = _props.id,
					    initialize_form = _props.initialize_form,
					    initial_values = _props.initial_values;

					// First `form.constructor` is called,
					// then `form.componentWillMount` is called,
					// then `field.constructor` is called,
					// then `field.componentWillMount` is called,
					// then `field.componentDidMount` is called,
					// then `form.componentDidMount` is called.

					initialize_form(id, initial_values);
				}
			}, {
				key: 'componentDidMount',
				value: function componentDidMount() {
					var onAbandoned = this.props.onAbandoned;
					var router = this.context.router;


					if (onAbandoned && router && router.setRouteLeaveHook) {
						// If the last route is left it means navigation takes place
						var route = router.routes[router.routes.length - 1];
						this.deactivate_route_leave_hook = router.setRouteLeaveHook(route, this.report_if_form_is_abandoned);
					}
				}
			}, {
				key: 'componentWillReceiveProps',
				value: function componentWillReceiveProps(new_props) {
					var initialized = this.props.initialized;

					// Autofocus the form when it's mounted and all of its fields are initialized.

					if (!initialized && new_props.initialized && options.autofocus !== false) {
						this.focus(undefined, new_props);
					}
				}
			}, {
				key: 'componentWillUnmount',
				value: function componentWillUnmount() {
					var _props2 = this.props,
					    id = _props2.id,
					    destroy_form = _props2.destroy_form;


					destroy_form(id);

					this.will_be_unmounted = true;

					this.report_if_form_is_abandoned();
				}
			}, {
				key: 'getChildContext',
				value: function getChildContext() {
					return {
						simpler_redux_form: (0, _context2.default)(this, options)
					};
				}
			}, {
				key: 'should_validate_visited_fields',
				value: function should_validate_visited_fields() {
					var validateVisitedFields = this.props.validateVisitedFields;


					if (validateVisitedFields !== undefined) {
						return validateVisitedFields;
					}

					if (options.validateVisitedFields !== undefined) {
						return options.validateVisitedFields;
					}

					if ((0, _configuration.get_configuration)().validateVisitedFields !== undefined) {
						return (0, _configuration.get_configuration)().validateVisitedFields;
					}
				}
			}, {
				key: 'should_trim_field_values',
				value: function should_trim_field_values() {
					if (options.trim !== undefined) {
						return options.trim;
					}

					if ((0, _configuration.get_configuration)().trim !== undefined) {
						return (0, _configuration.get_configuration)().trim;
					}
				}
			}, {
				key: 'stop_form_abandoned_listener',
				value: function stop_form_abandoned_listener() {
					if (this.deactivate_route_leave_hook) {
						this.deactivate_route_leave_hook();
					}
				}
			}, {
				key: 'register_field',


				// `value` is initial field value
				// (which is restored on form reset)
				value: function register_field(field, value, validate) {
					// The stored field info is used to `validate()` field `value`s 
					// and set the corresponding `error`s
					// when calling `set(field, value)` and `clear(field)`.
					// It also holds initial field values for form `reset()`.
					//
					// If a field happens to register the second time
					// (e.g. due to React "reconciliation" due to order change)
					// then no need to update its info.
					// This also prevents loosing the initial value of the field.
					//
					if (!this.fields[field]) {
						this.fields[field] = { value: value, validate: validate };
					}

					// This is used for `autofocus` feature
					if (!this.initially_first_field) {
						this.initially_first_field = field;
					}
				}
			}, {
				key: 'unregister_field',
				value: function unregister_field(field, value, validate) {}
				// The field info is not deleted on "unregister"
				// because this field can then be mounted right away after unmounting
				// due to internal React trickery ("reconciliation").
				// Therefore field info is retained.
				// This also preserves the initial value of the field.
				// delete this.fields[field]


				// Public API


				// Public API


				// Resets invalid indication for the whole form


				// Is called when the form has been submitted.

			}, {
				key: 'validate',
				value: function validate() {
					var _props3 = this.props,
					    id = _props3.id,
					    fields = _props3.fields,
					    values = _props3.values,
					    errors = _props3.errors,
					    set_form_validation_passed = _props3.set_form_validation_passed,
					    indicate_invalid_field = _props3.indicate_invalid_field;

					// Ignores previous form submission errors until validation passes

					set_form_validation_passed(id, false);

					// Revalidate fields.
					// (because normally they only get validated
					//  in `onChange` handlers, and advanced `validate()`
					//  functions can be realtime (stateful) rather than stateless,
					//  e.g. depending on `this.state` properties)
					for (var _iterator2 = Object.keys(fields), _isArray2 = Array.isArray(_iterator2), _i2 = 0, _iterator2 = _isArray2 ? _iterator2 : _iterator2[Symbol.iterator]();;) {
						var _ref3;

						if (_isArray2) {
							if (_i2 >= _iterator2.length) break;
							_ref3 = _iterator2[_i2++];
						} else {
							_i2 = _iterator2.next();
							if (_i2.done) break;
							_ref3 = _i2.value;
						}

						var field = _ref3;

						this.set_field(field, values[field]);
					}

					// Check if there are any invalid fields
					var invalid_fields = Object.keys(fields).filter(function (field) {
						return fields[field];
					}).filter(function (field) {
						return errors[field] !== undefined;
					});

					// If some of the form fields are invalid
					if (invalid_fields.length > 0) {
						// Indicate the first invalid field error
						indicate_invalid_field(id, invalid_fields[0]);

						// Scroll to the invalid field
						this.scroll_to_field(invalid_fields[0]);

						// Focus the invalid field
						this.focus_field(invalid_fields[0]);

						return false;
					}

					// Stop ignoring form submission errors
					set_form_validation_passed(id, true);
				}
			}, {
				key: 'collect_form_data',
				value: function collect_form_data() {
					var _props4 = this.props,
					    fields = _props4.fields,
					    values = _props4.values;

					// Pass only registered fields to form submit action
					// (because if a field is unregistered that means that
					//  its React element was removed in the process,
					//  and therefore it's not needed anymore)

					var should_trim = this.should_trim_field_values();
					return Object.keys(fields).reduce(function (form_data, field) {
						var value = values[field];

						if (should_trim && typeof value === 'string') {
							value = value.trim();
						}

						form_data[field] = value;
						return form_data;
					}, {});
				}

				// Calls `<form/>`'s `onSubmit` action.

			}, {
				key: 'execute_form_action',
				value: function execute_form_action(action, form_data) {
					var result = void 0;

					try {
						result = action(form_data);
					} catch (error) {
						if (this.handle_error(error) === false) {
							throw error;
						}
					}

					// If the form submit action returned a `Promise`
					// then track this `Promise`'s progress.
					if (result && typeof result.then === 'function') {
						this.submit_promise(result);
					} else {
						this.form_submitted();
					}
				}
			}, {
				key: 'submit_promise',


				// Is called when `<form/>` `onSubmit` returns a `Promise`.
				value: function submit_promise(promise) {
					var _this2 = this;

					this.setState({ submitting: true });

					var throw_error = void 0;
					promise.then(this.form_submitted, function (error) {
						if (_this2.handle_error(error) === false) {
							throw_error = error;
						}
					}).then(function () {
						if (!_this2.will_be_unmounted) {
							// Set `submitting` flag back to `false`
							_this2.setState({ submitting: false });
						}

						if (throw_error) {
							throw throw_error;
						}
					});
				}

				// Creates form submit handler
				// (this function is passed as a property)

			}, {
				key: 'on_submit',
				value: function on_submit(event, before_submit, action) {
					// If it's an event handler then `.preventDefault()` it
					// (which is the case for the intended
					//  `<form onSubmit={ submit(...) }/>` use case)
					if (event && typeof event.preventDefault === 'function') {
						event.preventDefault();
					}

					// Do nothing if the form is submitting
					// (i.e. submit is in progress)
					if (this.state.submitting || this.props.submitting) {
						return false;
					}

					// Can be used, for example, to reset
					// custom error messages.
					// (not <Field/> `error`s)
					// E.g. it could be used to reset
					// overall form errors like "Form submission failed".
					if (before_submit) {
						before_submit();
					}

					// Submit the form if it's valid.
					// Otherwise mark invalid fields.
					if (this.validate() === false) {
						return false;
					}

					this.execute_form_action(action, this.collect_form_data());
				}

				// Focuses on a given form field (used internally + public API)


				// Scrolls to a form field (used internally + public API)


				// Clears field value (public API)


				// Gets field value (public API)


				// Sets field value (public API)


				// Gets the latest focused field (public API).
				// (e.g. for Google Analytics on abandoned forms)

			}, {
				key: 'passthrough_props',


				// Pass through all non-internal React `props`
				value: function passthrough_props() {
					var passed_props = {};

					// Drop all inner props.
					// All other user-specified props are passed on.
					for (var _iterator3 = Object.keys(this.props), _isArray3 = Array.isArray(_iterator3), _i3 = 0, _iterator3 = _isArray3 ? _iterator3 : _iterator3[Symbol.iterator]();;) {
						var _ref4;

						if (_isArray3) {
							if (_i3 >= _iterator3.length) break;
							_ref4 = _iterator3[_i3++];
						} else {
							_i3 = _iterator3.next();
							if (_i3.done) break;
							_ref4 = _i3.value;
						}

						var prop_name = _ref4;

						// Drop all inner props
						if (Form.propTypes[prop_name] || form_state_properties[prop_name]) {
							continue;
						}

						passed_props[prop_name] = this.props[prop_name];
					}

					return passed_props;
				}
			}, {
				key: 'extra_props',
				value: function extra_props() {
					return {
						ref: this.store_instance,
						reset: this.reset,
						submit: this.submit,
						focus: this.focus,
						scroll: this.scroll_to_field,
						clear: this.clear_field,
						get: this.get_field_value,
						set: this.set_field,
						submitting: this.state.submitting || this.props.submitting,
						resetInvalidIndication: this.reset_form_invalid_indication,
						// Deprecated, use camelCase name instead.
						reset_invalid_indication: this.reset_form_invalid_indication,
						getLatestFocusedField: this.get_latest_focused_field
					};
				}
			}, {
				key: 'render',
				value: function render() {
					return (0, _react.createElement)(FormComponent, _extends({}, this.passthrough_props(), this.extra_props()));
				}
			}]);

			return Form;
		}(_react.Component), _class.propTypes = {
			// Form id (required)
			// (is set by the @Form() decorator)
			id: _propTypes2.default.string,

			// These two React properties
			// can be set on the decorated form element
			// and they will be transformed into the `id` property above.
			form_id: _propTypes2.default.string,
			formId: _propTypes2.default.string,

			// Initial form field values
			// (is set by the @Form() decorator
			//  gathering `value`s from all `<Field/>`s)
			initial_values: _propTypes2.default.object,

			// Whether the form is being submitted right now
			// (is set by the @Form() decorator's `submitting` option)
			submitting: _propTypes2.default.bool
		}, _class.contextTypes = {
			router: _propTypes2.default.object
		}, _class.childContextTypes = {
			simpler_redux_form: _context.context_prop_type
		}, _temp2);

		// A more meaningful React `displayName`

		Form.displayName = 'Form(' + get_display_name(FormComponent) + ')';

		// Connect the form component to Redux state
		var Connected_form = (0, _connect2.default)(options)(Form);

		// Build an outer component
		// with the only purpose
		// to expose instance API methods
		var ReduxForm = (0, _wrapper2.default)(Connected_form, options);

		// Preserve all static methods and properties
		// defined on the original decorated component
		return (0, _hoistNonReactStatics2.default)(ReduxForm, FormComponent);
	};
}

function get_display_name(Wrapped) {
	return Wrapped.displayName || Wrapped.name || 'Component';
}

function normalize_options(options) {
	if (typeof options === 'string') {
		options = { id: options };
	} else {
		options = _extends({}, options);
	}

	return options;
}

var decorator = decorator_with_options();
exports.default = decorator;


var form_state_properties = Object.keys((0, _reducer.initial_form_state)());
//# sourceMappingURL=form.js.map