'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = build_outer_component;
exports.submit_child_form = submit_child_form;

var _react = require('react');

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _configuration = require('../configuration');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Build an outer component
// with the only purpose
// to expose instance API methods
function build_outer_component(Connected_form, options) {
	var wrapper = function (_Component) {
		_inherits(ReduxForm, _Component);

		function ReduxForm() {
			_classCallCheck(this, ReduxForm);

			var _this = _possibleConstructorReturn(this, (ReduxForm.__proto__ || Object.getPrototypeOf(ReduxForm)).call(this));

			_this.get_form_id = _this.get_form_id.bind(_this);

			_this.ref = _this.ref.bind(_this);
			_this.focus = _this.focus.bind(_this);
			_this.scroll = _this.scroll.bind(_this);
			_this.clear = _this.clear.bind(_this);
			_this.set = _this.set.bind(_this);
			return _this;
		}

		// Legacy method, may be removed in some future major version.


		_createClass(ReduxForm, [{
			key: 'ref',
			value: function ref() {
				return this.getWrappedInstance();
			}
		}, {
			key: 'getWrappedInstance',
			value: function getWrappedInstance() {
				return this.connected_form.getWrappedInstance().user_form;
			}
		}, {
			key: 'focus',
			value: function focus(field) {
				return this.connected_form.getWrappedInstance().focus(field);
			}
		}, {
			key: 'scroll',
			value: function scroll(field) {
				return this.connected_form.getWrappedInstance().scroll_to_field(field);
			}
		}, {
			key: 'clear',
			value: function clear(field) {
				return this.connected_form.getWrappedInstance().clear_field(field);
			}
		}, {
			key: 'get',
			value: function get(field) {
				return this.connected_form.getWrappedInstance().get_field_value(field);
			}
		}, {
			key: 'set',
			value: function set(field, value) {
				return this.connected_form.getWrappedInstance().set_field(field, value);
			}

			// Gets the latest focused field (public API).
			// (e.g. for Google Analytics on abandoned forms)

		}, {
			key: 'getLatestFocusedField',
			value: function getLatestFocusedField() {
				return this.connected_form.getWrappedInstance().get_latest_focused_field();
			}

			// Deprecated alias.

		}, {
			key: 'get_latest_focused_field',
			value: function get_latest_focused_field() {
				return this.getLatestFocusedField();
			}
		}, {
			key: 'reset',
			value: function reset() {
				return this.connected_form.getWrappedInstance().reset();
			}
		}, {
			key: 'submit',
			value: function submit() {
				return submit_child_form(_reactDom2.default.findDOMNode(this.connected_form));
			}
		}, {
			key: 'getValues',
			value: function getValues() {
				var values = void 0;
				this.connected_form.getWrappedInstance().on_submit(null, null, function (_) {
					return values = _;
				});
				return values;
			}

			// Autogenerates form id and keeps returning it from then on.
			// The form id is stored in `this.form_id` instance variable.
			// This way every time a form is mounted
			// (if it's not reused by React in which case `key`s will do the trick)
			// a new form id is generated.

		}, {
			key: 'get_form_id',
			value: function get_form_id(state, props, options) {
				// If this function is called a subsequent time
				// then return an already autogenerated form id.
				if (!this.form_id) {
					this.form_id = _get_form_id(state, props, options);
				}

				return this.form_id;
			}
		}, {
			key: 'render',
			value: function render() {
				var _this2 = this;

				return (0, _react.createElement)(Connected_form, _extends({}, this.props, {
					ref: function ref(_ref) {
						return _this2.connected_form = _ref;
					},
					get_form_id: this.get_form_id
				}));
			}
		}]);

		return ReduxForm;
	}(_react.Component);

	// Proxy some instance methods (if specified)
	if (options.methods) {
		var _loop = function _loop() {
			if (_isArray) {
				if (_i >= _iterator.length) return 'break';
				_ref2 = _iterator[_i++];
			} else {
				_i = _iterator.next();
				if (_i.done) return 'break';
				_ref2 = _i.value;
			}

			var method = _ref2;

			if (wrapper.prototype[method]) {
				console.error('Form method "' + method + '" is already defined');
			}

			wrapper.prototype[method] = function () {
				var instance_method = this.getWrappedInstance()[method];

				if (!instance_method) {
					throw new Error('Instance method not found: "' + method + '"');
				}

				instance_method.apply(this, arguments);
			};
		};

		for (var _iterator = options.methods, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
			var _ref2;

			var _ret = _loop();

			if (_ret === 'break') break;
		}
	}

	return wrapper;
}

// Get form id
function _get_form_id(state, props, options) {
	// If `id` was set in the decorator options
	if (options.id) {
		// `id` can be either a String or a Function of `props`
		return typeof options.id === 'string' ? options.id : options.id(props);
	}

	// camelCase aliasing for `formId` property on the decorated component
	if (props.form_id || props.formId) {
		return props.form_id || props.formId;
	}

	// Autogenerate @Form() `id`.
	return autogenerate_form_id(state[(0, _configuration.get_configuration)().reducer]);
}

// Autogenerate @Form() `id`
//
// `@connect()` will be called in `Form` constructor,
// and form is registered in `componentWillMount` of a `Form`,
// which means that theoretically if two forms
// were created side-by-side in a parent component
// and then mounted inside it, then there potentially
// could be an ID collision, but that's very unlikely.
//
function autogenerate_form_id(forms) {
	// Generate a random form ID.
	// Since there's no multiply-and-floor involved here
	// it is considered really random (much safe, such PRNG)
	// https://medium.com/@betable/tifu-by-using-math-random-f1c308c4fd9d
	var id = String(Math.random()).slice(2);

	// If this form ID is already taken,
	// then try another one.
	if (forms[id]) {
		return autogenerate_form_id(forms);
	}

	return id;
}

function submit_child_form(node) {
	while (node.firstChild) {
		node = node.firstChild;
		if (node instanceof HTMLFormElement) {
			// Won't use `node.submit()` because it bypasses `onSubmit`.
			// Will click the submit button instead.
			var submit = node.querySelector('button[type=submit]');
			if (submit) {
				submit.click();
				return true;
			}
		}
	}
}
//# sourceMappingURL=wrapper.js.map