'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
var initialize_form = exports.initialize_form = function initialize_form(form, values) {
	return {
		type: '@@simpler-redux-form/initialize',
		form: form,
		values: values
	};
};

var destroy_form = exports.destroy_form = function destroy_form(form) {
	return {
		type: '@@simpler-redux-form/destroy',
		form: form
	};
};

var register_field = exports.register_field = function register_field(form, field, value, validate, non_validation_error) {
	return {
		type: '@@simpler-redux-form/register-field',
		form: form,
		field: field,
		value: value,
		validate: validate,
		non_validation_error: non_validation_error
	};
};

var unregister_field = exports.unregister_field = function unregister_field(form, field) {
	return {
		type: '@@simpler-redux-form/unregister-field',
		form: form,
		field: field
	};
};

var update_field_value = exports.update_field_value = function update_field_value(form, field, value, error) {
	return {
		type: '@@simpler-redux-form/changed',
		form: form,
		field: field,
		value: value,
		error: error
	};
};

var indicate_invalid_field = exports.indicate_invalid_field = function indicate_invalid_field(form, field) {
	return {
		type: '@@simpler-redux-form/indicate-invalid',
		form: form,
		field: field
	};
};

var reset_invalid_indication = exports.reset_invalid_indication = function reset_invalid_indication(form, field) {
	return {
		type: '@@simpler-redux-form/dont-indicate-invalid',
		form: form,
		field: field
	};
};

var clear_field = exports.clear_field = function clear_field(form, field, error) {
	return {
		type: '@@simpler-redux-form/set',
		form: form,
		field: field,
		error: error
	};
};

var set_field = exports.set_field = function set_field(form, field, value, error) {
	return {
		type: '@@simpler-redux-form/set',
		form: form,
		field: field,
		value: value,
		error: error
	};
};

var focus_field = exports.focus_field = function focus_field(form, field) {
	return {
		type: '@@simpler-redux-form/focus',
		form: form,
		field: field
	};
};

var focused_field = exports.focused_field = function focused_field(form, field) {
	return {
		type: '@@simpler-redux-form/focused',
		form: form,
		field: field
	};
};

var scroll_to_field = exports.scroll_to_field = function scroll_to_field(form, field) {
	return {
		type: '@@simpler-redux-form/scroll',
		form: form,
		field: field
	};
};

var scrolled_to_field = exports.scrolled_to_field = function scrolled_to_field(form, field) {
	return {
		type: '@@simpler-redux-form/scrolled',
		form: form,
		field: field
	};
};

var on_field_focused = exports.on_field_focused = function on_field_focused(form, field) {
	return {
		type: '@@simpler-redux-form/on-field-focused',
		form: form,
		field: field
	};
};

var set_form_validation_passed = exports.set_form_validation_passed = function set_form_validation_passed(form, passed) {
	return {
		type: '@@simpler-redux-form/validation-passed',
		form: form,
		passed: passed
	};
};

var reset_form_invalid_indication = exports.reset_form_invalid_indication = function reset_form_invalid_indication(form) {
	return {
		type: '@@simpler-redux-form/reset-invalid-indication',
		form: form
	};
};
//# sourceMappingURL=actions.js.map