'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = redux_state_connector;

var _reactRedux = require('react-redux');

var _configuration = require('../configuration');

function redux_state_connector(name, context) {
	return (0, _reactRedux.connect)(function (state) {
		// `context` seems to stay the same
		// while the contents of the `context`
		// seem to be recreated on each `prop`
		// or `state` change of the context provider.
		// https://facebook.github.io/react/docs/context.html#updating-context
		var form_state = state[(0, _configuration.get_configuration)().reducer][context.simpler_redux_form.get_id()];

		return {
			value: form_state.values[name],
			values: form_state.values,
			indicate_invalid: form_state.indicate_invalid[name],
			_focus: form_state.focus[name],
			_scroll_to: form_state.scroll_to[name],
			form_validation_failed: form_state.misc.validation_failed,
			initialized: true
		};
	}, undefined, undefined, {
		withRef: true
	});
}
//# sourceMappingURL=connect.js.map