'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _scrollIntoViewIfNeeded = require('scroll-into-view-if-needed');

var _scrollIntoViewIfNeeded2 = _interopRequireDefault(_scrollIntoViewIfNeeded);

var _field = require('./field');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// This component will be `@connect()`ed to Redux state
// and therefore will update itself when its value changes.
// (or when its invalid indication changes)
// Also watches `focus` flag for changes
// and updates its focus accordingly.
// Also watches `scroll_to` flag for changes
// and scrolls to this field upon request.
//
// The name was originally `ConnectableField`
// but was later changed to `SimplerReduxFormField`
// for more user-friendly React error messages and warnings.
//
var SimplerReduxFormField = (_temp = _class = function (_Component) {
	_inherits(SimplerReduxFormField, _Component);

	function SimplerReduxFormField(props, context) {
		_classCallCheck(this, SimplerReduxFormField);

		var _this = _possibleConstructorReturn(this, (SimplerReduxFormField.__proto__ || Object.getPrototypeOf(SimplerReduxFormField)).call(this, props, context));

		_this.focus = _this.focus.bind(_this);

		// If this field is being focused programmatically, then do it.
		_this.focus_if_requested({}, props, context);

		// // If this field is being scrolled to programmatically, then do it.
		// this.scroll_if_requested({}, props, context)
		return _this;
	}

	// `.focus()` didn't work without a timeout in `componentWillReceiveProps`,
	// therefore using `componentDidUpdate` here (shouldn't be much of a deal
	// since `state` is not used in this component, so an update means updated props)


	_createClass(SimplerReduxFormField, [{
		key: 'componentDidUpdate',
		value: function componentDidUpdate(old_props) {
			var new_props = this.props;

			// If this field is being focused programmatically, then do it.
			this.focus_if_requested(old_props, new_props, this.context);

			// If this field is being scrolled to programmatically, then do it.
			this.scroll_if_requested(old_props, new_props, this.context);
		}
	}, {
		key: 'componentDidMount',
		value: function componentDidMount() {
			this.mounted = true;
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			this.mounted = false;
		}

		// If this field is being focused programmatically, then do it.

	}, {
		key: 'focus_if_requested',
		value: function focus_if_requested(old_props, new_props, context) {
			if (!old_props._focus && new_props._focus) {
				// Focus the field.
				new_props.focused();
				this.focus();
			}
		}

		// Focuses the field (e.g. in case of validation errors)

	}, {
		key: 'focus',
		value: function focus() {
			if (!this.mounted) {
				return;
			}

			// If the form hasn't been unmounted yet
			// and an underlying component is a `React.Component`.
			if (this.field) {
				// If the custom React component has a `.focus()` instance method
				if (typeof this.field.focus === 'function') {
					return this.field.focus();
				}

				// Generic focusing
				return _reactDom2.default.findDOMNode(this.field).focus();
			}

			// React throws when calling `findDOMNode` on an unmounted component
			// therefore the explicit check for the component being still mounted.

			var node = _reactDom2.default.findDOMNode(this);

			var focusable = node.querySelector('input') || node.querySelector('select') || node.querySelector('textarea') || node.querySelector('button');

			if (focusable) {
				focusable.focus();
			}
		}

		// If this field is being scrolled to programmatically, then do it.

	}, {
		key: 'scroll_if_requested',
		value: function scroll_if_requested(old_props, new_props, context) {
			if (!old_props._scroll_to && new_props._scroll_to) {
				// Focus the field.
				// Do it in a timeout, otherwise it didn't work.
				// Probably because React rerenders this field
				// because the `props` have changed
				// and that discards the focus.
				new_props.scrolled();
				this.scroll();
			}
		}

		// Scrolls to the field (e.g. in case of validation errors)

	}, {
		key: 'scroll',
		value: function scroll() {
			// If the form hasn't been unmounted yet
			if (this.field) {
				// https://github.com/stipsan/scroll-into-view-if-needed/issues/359

				// scrollIntoView(ReactDOM.findDOMNode(this.field),
				// {
				// 	scrollMode : 'if-needed',
				// 	behavior   : 'smooth',
				// 	block      : 'nearest',
				// 	inline     : 'nearest'
				// })

				(0, _scrollIntoViewIfNeeded2.default)(_reactDom2.default.findDOMNode(this.field), false, { duration: 800 });
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			// These props will be passed down to the field
			var rest_props = {};

			// Properties used for inner operation won't be passed down.
			// All other properties will be passed down.
			for (var _iterator = Object.keys(this.props), _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
				var _ref;

				if (_isArray) {
					if (_i >= _iterator.length) break;
					_ref = _iterator[_i++];
				} else {
					_i = _iterator.next();
					if (_i.done) break;
					_ref = _i.value;
				}

				var prop = _ref;

				if (intercepted_properties.indexOf(prop) === -1) {
					rest_props[prop] = this.props[prop];
				}
			}

			var _props = this.props,
			    component = _props.component,
			    value = _props.value,
			    values = _props.values,
			    validate = _props.validate,
			    required = _props.required,
			    form_validation_failed = _props.form_validation_failed;
			var _props2 = this.props,
			    error = _props2.error,
			    indicate_invalid = _props2.indicate_invalid;

			// Makes sure `indicateInvalid` is always set to some `boolean` value.

			if (indicate_invalid === undefined) {
				indicate_invalid = false;
			}

			// If the form validation doesn't pass
			// then don't show externally set `error` property for this field
			// (reset the `error` to the form validation one),
			// i.e. the user must first correct the form field values
			// so that the form validation passes
			// and after that can he resubmit the form
			// and deal with those externally set `error`s.
			//
			// (`indicate_invalid` is set to `true`
			//  the moment `error` property is set externally;
			//  this is achieved using `componentWillReceiveProps()` hook)
			//
			if (indicate_invalid && form_validation_failed) {
				error = validate(value, values);
				indicate_invalid = error ? true : false;
			}
			// Else, don't override the externally set `error` (if it has been set).
			else {
					error = error || validate(value, values);
				}

			// Required for focusing on the field in case of validation errors
			if (!is_stateless(component)) {
				rest_props.ref = function (ref) {
					return _this2.field = ref;
				};
			}

			// For generic Html elements (<input/>, etc)
			if (typeof component === 'string') {
				return (0, _react.createElement)(component, rest_props);
			}

			// For custom React components
			return (0, _react.createElement)(component, _extends({}, rest_props, {
				value: value,
				error: error,
				indicateInvalid: indicate_invalid,
				required: required && (0, _field.is_value_empty)(value) ? true : false
			}));
		}
	}]);

	return SimplerReduxFormField;
}(_react.Component), _class.propTypes = {
	component: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.func]).isRequired,
	value: _propTypes2.default.any,
	values: _propTypes2.default.object.isRequired,
	indicate_invalid: _propTypes2.default.bool,
	error: _propTypes2.default.string,
	_focus: _propTypes2.default.bool,
	_scroll_to: _propTypes2.default.bool,
	form_validation_failed: _propTypes2.default.bool,
	validate: _propTypes2.default.func,
	focused: _propTypes2.default.func.isRequired,
	scrolled: _propTypes2.default.func.isRequired,

	// Whether this form field has been "initialized".
	// A form field is "intiialized" when its `@connect()`
	// has been called for the first time.
	initialized: _propTypes2.default.bool
}, _temp);
exports.default = SimplerReduxFormField;


var intercepted_properties = Object.keys(SimplerReduxFormField.propTypes).concat(['dispatch']);

function is_stateless(Component) {
	return typeof Component !== 'string' && !Component.prototype.render;
}
//# sourceMappingURL=connectable.js.map