'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp, _initialiseProps;

exports.is_value_empty = is_value_empty;

var _react = require('react');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _context = require('../form/context');

var _connect = require('./connect');

var _connect2 = _interopRequireDefault(_connect);

var _connectable = require('./connectable');

var _connectable2 = _interopRequireDefault(_connectable);

var _configuration = require('../configuration');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// <Field
// 	name="password"
// 	component={ TextInput }
// 	value={...}
// 	validate={...}
// 	error={...}/>
//
// React will optimize form rerendering,
// and in case of adding or removing form fields
// it will reuse and reshuffle `<Field/>` components for all form fields.
// And it did have messy side-effects.
// Therefore the need to "register" and "unregister" form fields
// while preserving all thier values in Redux state
// (to retain those values between rerenders).
// Alternatively, a developer could specify React `key`s
// for all `<Field/>`s but that would be verbose
// and also prone to "forgot to ket a key" bugs.
//
var Field = (_temp = _class = function (_Component) {
	_inherits(Field, _Component);

	function Field(props, context) {
		_classCallCheck(this, Field);

		var _this = _possibleConstructorReturn(this, (Field.__proto__ || Object.getPrototypeOf(Field)).call(this, props, context));

		_initialiseProps.call(_this);

		_this.validate = _this.create_validation_function();

		var _this$props = _this.props,
		    name = _this$props.name,
		    value = _this$props.value;

		// This underlying field component
		// will update itself when its value changes
		// (or when its invalid indication flag changes)

		_this.Connected_field = _this.create_connected_field_component(name, _this.context);
		return _this;
	}

	// Creates an underlying field component
	// `@connect()`ing it to Redux state.
	// Therefore it will rerender itself when the field value changes.
	// (or when its invalid indication flag changes)


	_createClass(Field, [{
		key: 'create_connected_field_component',
		value: function create_connected_field_component(name, context) {
			return (0, _connect2.default)(name, context)(_connectable2.default);
		}

		// Setting up the form field.

	}, {
		key: 'componentWillMount',
		value: function componentWillMount() {
			var _props = this.props,
			    name = _props.name,
			    value = _props.value,
			    error = _props.error;

			// "Register" field.
			//
			// Initializes this field with the default value,
			// if it hasn't been edited before (i.e. if it's really new).
			//
			// (because React will reuse and reshuffle all `<Fields/>` and it could get messy)
			//
			// (by this time the field could already exist (in the form))
			//
			// `value` is the initial value for this field.
			// If the field didn't exist in the form before,
			// then its value will be set to this initial value.
			// Otherwise, this "register" call does nothing.
			//
			// If `value` was not set
			// but `values` on the decorated form component were set,
			// then the initial value is taken from that
			// `values` setting in the reducer
			// (because it already holds those initial `values` by this time).
			// Therefore just passing `value` here,
			// not `value || initial_value`.
			//

			this.context.simpler_redux_form.register_field(name, value, this.validate, error);
		}

		// Is only called on client side.

	}, {
		key: 'componentDidMount',
		value: function componentDidMount() {
			this.mounted = true;
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			var name = this.props.name;

			// "Unregister" field
			//
			// ("registering" and "unregistering" fields because
			//  React will reuse and reshuffle all `<Fields/>` and it could get messy)
			//

			this.context.simpler_redux_form.unregister_field(name);
		}
	}, {
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(new_props) {
			// In case React reused one `<Field/>` element for another form field
			// (an alternative solution to specifying `key`s on each `<Field/>`)
			if (this.props.name !== new_props.name) {
				var name = new_props.name,
				    value = new_props.value,
				    error = new_props.error;

				// This field will update itself when its value changes
				// (or when it's invalid indication flag changes)

				this.Connected_field = this.create_connected_field_component(name, this.context);

				// Unregister old field
				this.context.simpler_redux_form.unregister_field(this.props.name);

				// Register new field
				//
				// Initialize this field with the default value,
				// if it hasn't been edited before (i.e. if it's really new).
				//
				this.context.simpler_redux_form.register_field(name, value, this.validate, error);
			}
			// Else, if it's the same field
			else {
					// If the default value changed for this `<Field/>`
					// and the field hasn't been edited yet
					// then apply this new initial value.
					if (new_props.value !== this.props.value && !this.has_been_edited) {
						var _name = new_props.name,
						    _value = new_props.value;

						this.context.simpler_redux_form.update_field_value(_name, _value, this.validate(_value));
					}

					// If an externally set `error` property is updated,
					// then set `indicate_invalid` to `true` for this field.
					this.show_or_hide_externally_set_error(this.props, new_props, this.context);
				}
		}

		// If an externally set `error` property is updated to another error,
		// and the field is not already being indicated as invalid,
		// then set `state.form[form].indicate_invalid[field]` to `true`.
		//
		// If an externally set `error` property is unset,
		// and the field has no validation error,
		// then set `state.form[form].indicate_invalid[field]` to `false`.
		//

	}, {
		key: 'show_or_hide_externally_set_error',
		value: function show_or_hide_externally_set_error(props, new_props, context) {
			// If the error didn't change then don't show it.
			// If the same error happened once again,
			// then it should have been reset
			// before sending form data to the server,
			// and in that case it will be shown once again
			// (see the readme for more info on this case:
			//  https://github.com/catamphetamine/simpler-redux-form#field-errors)
			if (props.error === new_props.error) {
				return;
			}

			var name = new_props.name,
			    error = new_props.error,
			    value = new_props.value,
			    indicate_invalid = new_props.indicate_invalid;


			if (error && !indicate_invalid) {
				context.simpler_redux_form.indicate_invalid_field(name);

				// Scroll to field and focus after React rerenders the component.
				//
				// Because `this.setState({ submitting: false })`
				// will be called after this code,
				// `submitting` is still `true` at this time,
				// which means `busy` is `true`,
				// which in turn means that all `<Field/>`s are `disabled`,
				// and `disabled` `<input/>`s can't receive focus.
				//
				// Therefore set focus on the `<Field/>` in a timeout
				// so that this "request set focus" action happens after
				// `this.setState({ submitting: false })` is called in `form.js`.
				// This way focus will be set after the `<input/>` is enabled
				// and therefore will be able to receive focus.
				//
				setTimeout(function () {
					context.simpler_redux_form.scroll_to_field(name);
					context.simpler_redux_form.focus_field(name);
				}, 0);
			} else if (props.error && !error && indicate_invalid && !this.validate(value)) {
				// So that `indicate_invalid === true` always means that
				// there is a non-empty `error`.
				// And if there's no error then `indicate_invalid` is always `false`.
				context.simpler_redux_form.reset_invalid_indication(name);
			}

			// The rest (imaginary) case is when the `error` is cleared
			// but the validation doesn't pass,
			// and it's uncertain whether to
			// indicate this field as invalid or not.
		}

		// `onChange` field value handler


		// `onFocus` field handler


		// `onBlur` field handler


		// Focuses on a field (can be called externally through a ref)


		// Focus on a field was requested and performed

	}, {
		key: 'create_validation_function',
		value: function create_validation_function() {
			var _this2 = this;

			var _props2 = this.props,
			    validate = _props2.validate,
			    required = _props2.required;


			return function (value) {
				if (required && is_value_empty(value)) {
					// Inputs are inherently an interactive concept
					// hence the actual "Required" error can only be shown
					// during the interaction, not as part of the initial page render.
					// Therefore only using `defaultRequiredMessage` in a web browser.
					// The actual "Required" error message during the initial page render
					// doesn't make any difference by itself since it's not shown anywhere.
					return typeof required === 'string' ? required : _this2.mounted ? get_default_required_message(_this2.context.simpler_redux_form.get_props()) : 'Required';
				}

				if (validate) {
					return validate(value, _this2.context.simpler_redux_form.get_values());
				}
			};
		}
	}, {
		key: 'render',
		value: function render() {
			var _this3 = this;

			var disabled = this.props.disabled;

			// The underlying field component will rerender itself
			// on value changes (or other things like invalid status, focus, scroll),
			// therefore it's computationally efficient
			// because neither the whole form get rerendered
			// nor the `<Field/>` component:
			// just this `@connect()`ed underlying field component.

			return (0, _react.createElement)(this.Connected_field, _extends({}, this.props, {
				ref: function ref(_ref) {
					return _this3.field = _ref;
				},
				onChange: this.on_change,
				onFocus: this.on_focus,
				onBlur: this.on_blur,
				validate: this.validate,
				focused: this.focused,
				scrolled: this.scrolled,
				disabled: disabled || this.context.simpler_redux_form.is_submitting()
			}));
		}
	}]);

	return Field;
}(_react.Component), _class.propTypes = {
	name: _propTypes2.default.string.isRequired,
	required: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.string]),
	component: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.string]).isRequired,

	value: _propTypes2.default.any,
	error: _propTypes2.default.string,
	validate: _propTypes2.default.func,

	children: _propTypes2.default.node
}, _class.contextTypes = {
	simpler_redux_form: _context.context_prop_type
}, _initialiseProps = function _initialiseProps() {
	var _this4 = this;

	this.state = {};

	this.on_change = function (event) {
		var _props3 = _this4.props,
		    name = _props3.name,
		    onChange = _props3.onChange;


		var value = event;

		// If it's an event then extract the input value from it
		if (event && typeof event.preventDefault === 'function') {
			// The `value` seems to be trimmed by now which is handy
			value = event.target.value;
		}

		// Once a user enters/erases a value
		// the `value` (initial value) property
		// no longer changes the current value.
		_this4.has_been_edited = true;

		_this4.context.simpler_redux_form.update_field_value(name, value, _this4.validate(value));

		if (onChange) {
			onChange(event);
		}
	};

	this.on_focus = function (event) {
		var _props4 = _this4.props,
		    name = _props4.name,
		    onFocus = _props4.onFocus;


		_this4.context.simpler_redux_form.on_field_focused(name);

		if (onFocus) {
			onFocus(event);
		}
	};

	this.on_blur = function (event) {
		var _props5 = _this4.props,
		    name = _props5.name,
		    onBlur = _props5.onBlur;


		_this4.context.simpler_redux_form.field_visited(name);

		if (onBlur) {
			onBlur(event);
		}
	};

	this.focus = function () {
		_this4.field.getWrappedInstance().focus();
		_this4.focused();
	};

	this.focused = function () {
		var name = _this4.props.name;


		_this4.context.simpler_redux_form.focused_field(name);
	};

	this.scroll = function () {
		_this4.field.getWrappedInstance().scroll();
		_this4.scrolled();
	};

	this.scrolled = function () {
		var name = _this4.props.name;


		_this4.context.simpler_redux_form.scrolled_to_field(name);
	};
}, _temp);

// Provides support for legacy `defaultRequiredMessage: string`
// instead of it being a function.
// `defaultRequiredMessage: string` fallback
// should be removed in some next major version.

exports.default = Field;
function get_default_required_message(props) {
	var defaultRequiredMessage = (0, _configuration.get_configuration)().defaultRequiredMessage;

	if (typeof defaultRequiredMessage === 'string') {
		return defaultRequiredMessage;
	}

	return defaultRequiredMessage(props);
}

function is_value_empty(_) {
	return _ === undefined || _ === null || typeof _ === 'string' && _.trim() === '';
}
//# sourceMappingURL=field.js.map